/*
Copyright Renaud GICQUEL 2005-2006  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import extThopt.*;
import java.util.*; 
import javax.swing.*;

public class SolarConcentrator extends ExtProcess  implements Inversable
{
    
	final ButtonGroup groupSystemType=new ButtonGroup();
	javax.swing.JRadioButton calcT = new javax.swing.JRadioButton();
	javax.swing.JRadioButton calcSc = new javax.swing.JRadioButton();
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField tau_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField U0_value = new javax.swing.JTextField();
	javax.swing.JTextField U1_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField P_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField Sc_value = new javax.swing.JTextField();
	javax.swing.JTextField Sa_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField Tex_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField eff_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField compRef = new javax.swing.JTextField();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
    
    double tau, U0, U1, P, Sc, Sa, Tex;
    double Tamont, Taval, Pamont, Paval, Hamont, Haval, flow;
    
    public SolarConcentrator (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,400,300);
		JLabel1.setText("optical efficiency");
		JPanel1.add(calcT);
		calcT.setBounds(164,210,200,24);
		calcT.setText("Calculate outlet state");
		JPanel1.add(calcSc);
		calcSc.setBounds(164,240,200,24);
		calcSc.setText("Calculate collector area");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(0,0,164,20);
		JPanel1.add(tau_value);
		tau_value.setBounds(164,0,124,20);
		tau_value.setText("0.8");
		JLabel2.setText("U0 thermal loss coefficient");
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,24,164,20);
		JPanel1.add(U0_value);
		U0_value.setBounds(164,24,124,20);
		U0_value.setText("0.7");
		JLabel8.setText("U1 thermal loss coefficient");
		JPanel1.add(JLabel8);
		JLabel8.setBounds(0,48,164,20);
		JPanel1.add(U1_value);
		U1_value.setBounds(164,48,124,20);
		U1_value.setText("0.02");
		JLabel3.setText("solar flux (W/m2)");
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,72,164,20);
		JPanel1.add(P_value);
		P_value.setBounds(164,72,124,20);
		P_value.setText("1200");
		JLabel4.setText("collector area (m2)");
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,96,164,20);
		JPanel1.add(Sc_value);
		Sc_value.setBounds(164,96,124,20);
		Sc_value.setText("10");
		JLabel9.setText("absorber area (m2)");
	//	JPanel1.add(JLabel9);
		JLabel9.setBounds(0,120,164,20);
//		JPanel1.add(Sa_value);
		Sa_value.setBounds(164,120,124,20);
		Sa_value.setText("0.04");
		JLabel5.setText("outdoor temperature (C)");
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,144,164,20);
		JPanel1.add(Tex_value);
		Tex_value.setBounds(164,144,124,20);
		Tex_value.setText("10");
		JLabel6.setText("solar collector efficiency");
		JPanel1.add(JLabel6);
		JLabel6.setBounds(0,168,164,20);
		JPanel1.add(eff_value);
		eff_value.setBounds(164,168,124,20);
		eff_value.setText("0.8");
		JLabel7.setText("reference");
		JPanel1.add(JLabel7);
		JLabel7.setBounds(0,192,108,20);
		JPanel1.add(compRef);
		compRef.setBounds(108,192,192,20);
		type=getType();
   		thermoCouplerTypes=new String[0];//no thermocoupler connected
	    groupSystemType.add(calcT);
	    groupSystemType.add(calcSc);
	    calcT.setSelected(true);
 }
    
    public String getType(){
        return "solar concentrator";
    }
	public String getClassDescription(){
	    return "Solar concentrator\n\nauthor : R. Gicquel   march 2006";
	}
    
    
	public void calculateProcess(){
        String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        flow=f.doubleValue();
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
        String aval=(String)vProp.elementAt(2);//gets the upstream point name
        getPointProperties(amont);//direct parsing of point property vector
        Tamont=Tpoint;
        Hamont=Hpoint;
        Pamont=Ppoint;
        P=Util.lit_d(P_value.getText());
        Sc=Util.lit_d(Sc_value.getText());
        Sa=Util.lit_d(Sa_value.getText());
        double conc=Sc/Sa;
        tau=Util.lit_d(tau_value.getText());
        U0=Util.lit_d(U0_value.getText());
        U1=Util.lit_d(U1_value.getText());
        Tex=Util.lit_d(Tex_value.getText())+273.15;
        
        if(calcT.isSelected()){//calcul de l'tat de sortie        
            double Qex=(tau*P-(U0+U1*(Tamont-Tex))*(Tamont-Tex))*Sc/1000.;
           
        
            
            
            double hAvalMax=Qex/flow+Hamont;
        System.out.println(); 
		System.out.println("hAvalMax: " + hAvalMax); 
                    
//            double Haval=Util.dicho_T (this,0.,1., "calcSolar",Hamont, hAvalMax,0.001);
            Haval=Util.dicho_T (this,0.,1., "calcSolar",Hamont, hAvalMax,0.001);
        }
        else{
            getPointProperties(aval);
            Haval=Hpoint;
            Taval=Tpoint;
            System.out.println(); 
		    System.out.println("Taval: " + Taval); 
		    System.out.println(); 
		    System.out.println("Tamont: " + Tamont); 
		    System.out.println(); 
		    System.out.println("Haval: " + Haval); 
		    System.out.println(); 
		    System.out.println("Hamont: " + Hamont); 
		    
            double Qex=( Haval - Hamont)*flow;
            Sc=1;
            double Qex_Sc=((tau*P-(U0+U1*((Tamont+Tpoint)/2-Tex))*((Tamont+Tpoint)/2-Tex)))*Sc/1000.;
            System.out.println(); 
		    System.out.println("Qex_Sc: " + Qex_Sc); 
            
       //     flow = Qex_Sc/( Haval - Hamont);
            
            System.out.println(); 
		    System.out.println("flow: " + flow); 
            Sc=Qex/Qex_Sc;
	        Sc_value.setText(Util.aff_d(Sc,2));
		    //Sa=Sc/conc;
	        //Sa_value.setText(Util.aff_d(Sa,2));            
        }
        double eff=flow*(Haval-Hamont)/P*1000/Sc;
        
        tfe.setupPointAval(getProperties());
        eff_value.setText(Util.aff_d(eff, 4));
	    tfe.updateProcess(setEnergyTypes(tfe.getCompName(),0,flow*(Haval-Hamont),0));
	}
    
	public void readCompParameters(String ligne_data){
		tau=Util.lit_d(Util.extr_value(ligne_data, "tau_value"));
	    tau_value.setText(Util.aff_d(tau));
		U0=Util.lit_d(Util.extr_value(ligne_data, "U0_value"));
	    U0_value.setText(Util.aff_d(U0));
		U1=Util.lit_d(Util.extr_value(ligne_data, "U1_value"));
	    U1_value.setText(Util.aff_d(U1));
		P=Util.lit_d(Util.extr_value(ligne_data, "P_value"));
	    P_value.setText(Util.aff_d(P));
		Sc=Util.lit_d(Util.extr_value(ligne_data, "Sc_value"));
	    Sc_value.setText(Util.aff_d(Sc));
		Sa=Util.lit_d(Util.extr_value(ligne_data, "Sa_value"));
	    Sa_value.setText(Util.aff_d(Sa));
		Tex=Util.lit_d(Util.extr_value(ligne_data, "Tex_value"));
	    Tex_value.setText(Util.aff_d(Tex));
	    eff_value.setText(Util.extr_value(ligne_data, "eff_value"));
        String valeur="";
        valeur=Util.extr_value(ligne_data, "calcT_value");
        if(valeur!=null)calcT.setSelected(Util.lit_b(valeur));
        valeur=Util.extr_value(ligne_data, "calcSc_value");
        if(valeur!=null)calcSc.setSelected(Util.lit_b(valeur));
        valeur=Util.extr_value(ligne_data, "compRef");
        if(valeur!=null)compRef.setText(valeur);
        
	}
	
    public String saveCompParameters(){
	    String h="tau_value="+tau_value.getText()+tab
	    +"U0_value="+U0_value.getText()+tab
	    +"U1_value="+U1_value.getText()+tab
	    +"P_value="+P_value.getText()+tab
	    +"Sc_value="+Sc_value.getText()+tab
	    +"Sa_value="+Sa_value.getText()+tab
	    +"Tex_value="+Tex_value.getText()+tab
	    +"eff_value="+eff_value.getText()+tab
	    +"calcT_value="+Util.aff_b(calcT.isSelected()) +tab
	    +"calcSc_value="+Util.aff_b(calcSc.isSelected()) +tab
	    +"compRef="+compRef.getText()+tab
	    ;
        return h;
    }
 


    public double f_dicho(double h, double x,String fonc){
        
        if (fonc.equals("calcSolar")){
            double residu=0;
            Tpoint=lecorps.getT_from_hP(h,Ppoint);//on calcule T aval
            getSubstProperties(nomCorps);
            Xpoint=Xsubst;//et x aval
            double Qex=(tau*P-(U0+U1*((Tamont+Tpoint)/2-Tex))*((Tamont+Tpoint)/2-Tex))*Sc/1000;//on recalcule les pertes
            System.out.println(); 
		    System.out.println(" Qex: " + Qex); 
            residu=h-Qex/flow-Hamont;//et le nouveau rsidu
        //    System.out.println("T : "+Tpoint+"  Qex : "+Qex+" Hsubst : "+h+"  residu : "+residu);
            
            return residu;
            
        }

        return 0;
    }

}